#include "Particles.h"

Particle* Particle::ms_instance = 0;

Particle::Particle()
{
}

Particle::~Particle()
{
}

Particle* Particle::Instance()
{
	if(ms_instance == 0){
		ms_instance = new Particle();
	}
	return ms_instance;
}

void Particle::Release()
{
	if(ms_instance){
		delete ms_instance;
	}
	ms_instance = 0;
}

//--------------------------------------
//	
//--------------------------------------
void Particle::Init( glImage* const Sprites )
{
	
	Images = Sprites;
	Particles.resize( 64 );
	
}

//--------------------------------------
//	
//--------------------------------------
void Particle::Update()
{
	
	NumParticles = 0;
	std::vector<Part>::iterator iter;
	for( iter = Particles.begin(); iter != Particles.end(); ++iter )
	{
		if( iter->Active )
		{
			iter->Update();
			NumParticles++;
		}
	}
	
}

//--------------------------------------
//	
//--------------------------------------
void Particle::Draw()
{
	
	std::vector<Part>::iterator iter;
	for( iter = Particles.begin(); iter != Particles.end(); ++iter )
	{
		if( iter->Active )
		{
			int x = iter->Position.x >> 12;
			int y = iter->Position.y >> 12;
			glColor( RGB15( iter-> Red,iter->Green, iter->Blue ) );
			glSpriteRotateScaleXY( x, y, iter->Angle, 1600, 350, GL_FLIP_NONE, &Images[1]);
			
		}
	}
	
	
}

//--------------------------------------
//	
//--------------------------------------
void Particle::Spawn( Vector2df32 Pos, Vector2df32 Dir, Part::TYPE Type )
{
	
	
	std::vector<Part>::iterator iter;
	for( iter = Particles.begin(); iter != Particles.end(); ++iter )
	{
		if( !iter->Active )		// insert a bullet on a free slot
		{

			iter->Init( Pos , Dir, Type );
			break;
		
		}
	}
	
}

//--------------------------------------
//	
//--------------------------------------
void Particle::Spawn( Vector2df32 Pos, s32 Ang, Part::TYPE Type )
{
	
	
	std::vector<Part>::iterator iter;
	for( iter = Particles.begin(); iter != Particles.end(); ++iter )
	{
		if( !iter->Active )		// insert a bullet on a free slot
		{

			iter->Init( Pos , Ang, Type );
			break;
		
		}
	}
	
}


//--------------------------------------
//	
//--------------------------------------
void Particle::Spawn( Vector2df32 Pos, int NumParts )
{
	
	
	for( int i = 0; i < NumParts; i++ )
	{
	
		std::vector<Part>::iterator iter;
		for( iter = Particles.begin(); iter != Particles.end(); ++iter )
		{
			if( !iter->Active )		// insert a bullet on a free slot
			{
				s32 angle = UTIL::RND();
			
				iter->Init( Pos , angle, (Part::TYPE) (UTIL::RND() & 3) );
				break;
			
			}
		}
	
	}
	
}
