/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Tripod class


*******************************************************************************
******************************************************************************/


#include <nds.h>
#include <vector>
#include "Vector2df32.h"

#include "EntityContainer.h"
#include "StarFighter.h"
#include "Explosion.h"

#ifndef TRIPOD_H
#define TRIPOD_H

//------------------------------------------------------------------------------
//	Tripod Enemy
//------------------------------------------------------------------------------
class Tripod 
{

public:
	friend class TripodContainer;
	
	Tripod();
	~Tripod();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	s32		Speed;
	s32		Angle;
	s32		Delta;
	bool	NewTarget;
	bool	TargetMe;
	int 	Radius;
	int		Frame;
	int 	Counter;
	bool	Active;
	int 	Hp;
	
	Vector2df32 Target;
	
	EN_DRAW_MODE DrawMode;
	
	
};

//------------------------------------------------------------------------------
//	Tripod Container
//------------------------------------------------------------------------------
class TripodContainer : public EntityContainer
{	

public:

	TripodContainer();
    ~TripodContainer();
	void Init(int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
	void Spawn( int _x, int _y );
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Tripod> Tripods;
	
	
};

#endif // TRIPOD_H
